public CallAchievementEvent(String:event[128],any:target0, any:target1, any:target2, any:add) {
    // All this code does is check if the client meets the requirements.
    // It does not check if he already has the achievement.
    
    if (GetConVarInt(cvar_debug) == 1) PrintToChatAll("Event: %s, Target0: %N (%d), Target1: %N (%d)", event, target0, target0, target1, target1);
    new any:targets[3];
    targets[0] = target0;
    targets[1] = target1;
    targets[2] = target2;
    // Loop through all server blocks
    for (new i = 0; i < GetArraySize(g_Blocks_Server); i++) {
        new any:trie = GetArrayCell(g_Blocks_Server, i);
        decl String:tEvent[128];
        new any:tblockid;
        new any:triggers;
        new any:target;
        new any:tadd;
        GetTrieValue(trie, "triggers", triggers);
        GetTrieValue(trie, "target", target);
        GetTrieString(trie, "event", tEvent, sizeof(tEvent));
        GetTrieValue(trie, "id", tblockid);
        GetTrieValue(trie, "add", tadd);
        // If the activated event matches a block
        if (StrEqual(event, tEvent)) {
            new client = targets[target];
            if (GetConVarInt(cvar_debug) == 1) PrintToChatAll("Block %d, target is %N (id %d)", tblockid, client, target);
            if (IsValidClient(client)) {
                // Requirements
                decl String:tRequire[128];
                decl String:split[50][128];
                GetTrieString(trie, "requirement", tRequire, sizeof(tRequire));
                new explode = ExplodeString(tRequire, "|", split, sizeof(split), sizeof(split[]));
                new bool:allow = true;
                for (new i2 = 0; i2 < explode; i2++) {
                    decl String:split2[10][128];
                    new any:explode2 = ExplodeString(split[i2], ",", split2, sizeof(split2), sizeof(split2[]));
                    new any:req = StringToInt(split2[0]);
                    decl String:x[512];
                    decl String:y[512];
                    if (explode2 >= 1) Format(x, sizeof(x), split2[1]);
                    if (explode2 >= 2) Format(y, sizeof(y), split2[2]);
                    if (GetConVarInt(cvar_debug) == 1) PrintToChatAll("Req: %d, x: %s, y: %s, target0: %N, target1: %N, target2: %N", req, x, y, targets[0], targets[1], targets[2]);
                    if (Requirement(req, x, y, targets[0], targets[1], targets[2]) == false) allow = false;
                }
                if (GetConVarInt(cvar_debug) == 1) PrintToChatAll("Allow: %d", allow);
                if (allow && (IsFakeClient(client) && (GetConVarBool(cvar_bot) == false))) allow = false;
                if (GetConVarInt(cvar_debug) == 1) PrintToChatAll("Allow (after bot test): %d", allow);
                // If its a valid clients and requirements are OK
                if (allow) {
                    if (GetConVarInt(cvar_debug) == 1) PrintToChatAll("passed!");
                    new add_final = 1;
                    if (tadd >= 2) add_final = add;
                    CreateTrieBlock(client, tblockid);
                    AddToBlock(client, tblockid, add_final, triggers);
                }
            }
        }
    }
}

CreateTrieBlock(any:client, any:blockid) {
    if (!(IsValidClient(client))) return false;
    for (new i = 0; i < GetArraySize(g_Blocks_User); i++) {
        new any:trie = GetArrayCell(g_Blocks_User, i);
        new tblockid;
        new tclient;
        GetTrieValue(trie, "id", tblockid);
        GetTrieValue(trie, "client", tclient);
        if (tblockid == blockid && tclient == client) return true;
    }
    
    decl String:strSteamId[128];
    GetClientAuthString(client, strSteamId, sizeof(strSteamId));
    strSteamId[6] = '0';

    new Handle:trie = CreateTrie();
    // client
    SetTrieValue(trie, "client", client);
    // blockid
    SetTrieValue(trie, "id", blockid);
    // steamid
    SetTrieString(trie, "steamid", strSteamId);
    // triggers
    SetTrieValue(trie, "triggers", 0);
    // triggers
    SetTrieValue(trie, "complete", 0);
    // insert
    PushArrayCell(g_Blocks_User, trie);
    return false;
}

AddToBlock(any:client, any:block, any:amount, any:max) {
    new bool:checkforupdate = false;
    if (GetConVarInt(cvar_debug) == 2) PrintToChatAll("Adding to block %d for %N", block, client);
    for (new i = 0; i < GetArraySize(g_Blocks_User); i++) {
        new any:trie = GetArrayCell(g_Blocks_User, i);
        new any:tblockid;
        new any:tclient;
        GetTrieValue(trie, "id", tblockid);
        GetTrieValue(trie, "client", tclient);
        if (tblockid == block && tclient == client) {
            new triggers = 0;
            new complete = 0;
            GetTrieValue(trie, "triggers", triggers);
            GetTrieValue(trie, "complete", complete);
            if (complete <= 0) {
                if (GetConVarInt(cvar_debug) == 2) PrintToChatAll("Block %d, %d + %d = %d, max = %d", block, triggers, amount, triggers + amount, max);
                triggers += amount;
                SetTrieValue(trie, "triggers", triggers);
                if (triggers >= max) {
                    triggers = 0;
                    complete = 1;
                    SetTrieValue(trie, "complete", complete);
                    checkforupdate = true;
                    if (GetConVarInt(cvar_debug) == 2) PrintToChatAll("Block %d is completed", block);
                }
            }
        }
    }
    if (checkforupdate) CheckForAchievementUpdate(client);
}

CreateTrieAch(any:client, any:achid) {
    if (!(IsValidClient(client))) return false;
    for (new i = 0; i < GetArraySize(g_Achievements_User); i++) {
        new any:trie = GetArrayCell(g_Achievements_User, i);
        new any:tachid;
        new any:tclient;
        GetTrieValue(trie, "achid", tachid);
        GetTrieValue(trie, "client", tclient);
        if (tachid == achid && tclient == client) return true;
    }
    
    if (GetConVarInt(cvar_debug) == 2) PrintToChatAll("Trie for achievement %d (%N) unexisting. Creating...", achid, client);
    
    decl String:strSteamId[128];
    decl String:temp[128];
    GetClientAuthString(client, strSteamId, sizeof(strSteamId));
    strSteamId[6] = '0';
    
    new Handle:trie = CreateTrie();
    // client
    SetTrieValue(trie, "client", client);
    // id
    Format(temp, sizeof(temp), "%s_%d", strSteamId, achid);
    SetTrieString(trie, "id", temp);
    // achid
    SetTrieValue(trie, "achid", achid);
    // steamid
    SetTrieString(trie, "steamid", strSteamId);
    // triggers
    SetTrieValue(trie, "triggers", 0);
    // triggers
    SetTrieValue(trie, "complete", 0);
    // insert
    PushArrayCell(g_Achievements_User, trie);
    return false;
}

CheckForAchievementUpdate(any:client) {
    if (!(IsValidClient(client))) return;
    if (GetConVarInt(cvar_debug) == 2) PrintToChatAll("Checking achievement update for %N", client);
    for (new i = 0; i < GetArraySize(g_Achievements_Server); i++) {
        new any:trie = GetArrayCell(g_Achievements_Server, i);
        new any:tid;
        new any:tgame;
        GetTrieValue(trie, "id", tid);
        GetTrieValue(trie, "game", tgame);
        if ((tgame <= 0) || (tgame == g_Gamemode)) {
            CreateTrieAch(client, tid);
            for (new i2 = 0; i2 < GetArraySize(g_Achievements_User); i2++) {
                new any:trie2 = GetArrayCell(g_Achievements_User, i2);
                new any:tclient;
                new any:tachid;
                new tcomplete = 0;
                GetTrieValue(trie2, "achid", tachid);
                GetTrieValue(trie2, "client", tclient);
                GetTrieValue(trie2, "complete", tcomplete);
                if (GetConVarInt(cvar_debug) == 2) PrintToChatAll("complete: %d. %d = %d, %d = %d", tcomplete, tachid, tid, tclient, client);
                if (tachid == tid && tclient == client && tcomplete <= 0) {
                    if (GetConVarInt(cvar_debug) == 2) PrintToChatAll("Part 2!");
                    new String:blocks[128];
                    decl String:split[50][5];
                    GetTrieString(trie, "blocks", blocks, sizeof(blocks));
                    new explode = ExplodeString(blocks, "|", split, sizeof(split), sizeof(split[]));
                    new bool:isCompleted = true;
                    new block_count = 0;
                    for (new i3 = 0; i3 < explode; i3++) {
                        new any:block = StringToInt(split[i3]);
                        if (block > 0) {
                            CreateTrieBlock(client, block);
                            for (new i4 = 0; i4 < GetArraySize(g_Blocks_User); i4++) {
                                new any:trie3 = GetArrayCell(g_Blocks_User, i4);
                                new any:blockid = 0;
                                new any:blockclient = 0;
                                GetTrieValue(trie3, "id", blockid);
                                GetTrieValue(trie3, "client", blockclient);
                                if (blockid == block && IsValidClient(blockclient) && blockclient == client) {
                                    new any:blockcomplete = 0;
                                    GetTrieValue(trie3, "complete", blockcomplete);
                                    if (GetConVarInt(cvar_debug) == 2) PrintToChatAll("Block %d is completed: %d", block, blockcomplete);
                                    if (blockcomplete <= 0) isCompleted = false;
                                    block_count += 1;
                                }
                            }
                        }
                    }
                    if (isCompleted && block_count > 0) {
                        isCompleted = false;
                        new any:max;
                        new any:triggers;
                        GetTrieValue(trie, "triggers", max);
                        GetTrieValue(trie2, "triggers", triggers);
                        triggers += 1;
                        if (GetConVarInt(cvar_debug) == 2) PrintToChatAll("Added +1 to Achievement %d for %N", tid, client);
                        // Achievement is completed
                        if (triggers >= max) {
                            triggers = 0;
                            tcomplete += 1;
                            SetTrieValue(trie2, "complete", tcomplete);
                            new String:achname[128];
                            GetTrieString(trie, "name", achname, sizeof(achname));
                            new String:strMessage[200];
                            Format(strMessage, sizeof(strMessage), "\x03%N\x01 has earned the achievement \x05%s", client, achname);
                            SayText2(client,strMessage);
                            if (GetConVarBool(cvar_achinfo)) {
                                new String:achdesc[128];
                                GetTrieString(trie, "desc", achdesc, sizeof(achdesc));
                                Format(strMessage, sizeof(strMessage), "(\x05%s\x01)", achdesc);
                                SayText2(client,strMessage);
                            }
                            AchievementEffect(client);
                        }
                        SetTrieValue(trie2, "triggers", triggers);
                        
                        // Reset the blocks
                        for (new i5 = 0; i5 < explode; i5++) {
                            new any:block2 = StringToInt(split[i5]);
                            if (block2 > 0) {
                                new any:trie4 = GetArrayCell(g_Blocks_User, i5);
                                new any:blockclient2 = 0;
                                new any:blockid2 = 0;
                                GetTrieValue(trie4, "id", blockid2);
                                GetTrieValue(trie4, "client", blockclient2);
                                if (blockid2 == block2 && blockclient2 == client) {
                                    if (GetConVarInt(cvar_debug) == 2) PrintToChatAll("Resetting block %d for %N", blockid2, blockclient2);
                                    SetTrieValue(trie4, "complete", 0);
                                    SetTrieValue(trie4, "triggers", 0);
                                }
                            }
                        }
                        
                        // Update server-side
                        AddToUpdateClient(client, tid);
                    }
                }
            }
        }
    }
}

public ExpireBlocks(client, value) {
    if (client != -1 && (!IsValidClient(client) || (IsFakeClient(client) && GetConVarBool(cvar_bot) == false))) return;
    
    for (new i = 0; i < GetArraySize(g_Blocks_Server); i++) {
        new any:trie = GetArrayCell(g_Blocks_Server, i);
        new String:expvalue[512];
        new any:id;
        decl String:split[50][128];
        GetTrieString(trie, "expire", expvalue, sizeof(expvalue));
        GetTrieValue(trie, "id", id);
        new explode = ExplodeString(expvalue, "|", split, sizeof(split), sizeof(split[]));
        for (new i3 = 0; i3 < explode; i3++) {
            if (StringToInt(split[i3]) == value) {
                for (new i2 = 0; i2 < GetArraySize(g_Blocks_User); i2++) {
                    new any:trie2 = GetArrayCell(g_Blocks_User, i2);
                    new any:id2;
                    new any:tclient;
                    GetTrieValue(trie2, "id", id2);
                    GetTrieValue(trie2, "client", tclient);
                    if (client == -1 || tclient == client) {
                        if (id2 == id) {
                            SetTrieValue(trie2, "triggers", 0);
                            SetTrieValue(trie2, "complete", 0);
                        }
                    }
                }
            }
        }
    }
}

public AddToUpdateClient(client, id) {
    for (new i = 0; i < GetArraySize(g_Achievements_Update); i++) {
        new c_client = GetArrayCell(g_Achievements_Update, i);
        new c_id = GetArrayCell(g_Achievements_Update, i, 1);
        if (c_client == client && c_id == id) return;
    }
    new index = PushArrayCell(g_Achievements_Update, client);
    SetArrayCell(g_Achievements_Update, index, id, 1);
    g_ClientUpdate[client] = true;
}