// __COMMON__
// 1) x must be alive
// 2) x must be dead
// 3) x must have minimum y hp
// 4) x must have maximum y hp
// 5) Is not suicide (or anything self-inflicted)
// 6) Is suicide (or anything self-inflicted)
// 7) [chat] Chat input contains x
// 8) [chat] Chat input does not contain x
// 9) [chat] Chat input equals x
// 10) x's name contains y
// 11) x's name does not contain y
// 12) x's name equals y
// 13) x's steamid is y
// 14) x is class y (scout, soldier, demoman, smoker, jockey, zoey, nick ...)
// 15) x is team y (red, blu, survivor, infected, ...)
// 16) x is on team with y
// 17) x is not on team with y
// 18) x and y is the same person
// 19) x and y is not the same person
// 20) x's team has minimum y players alive
// 21) x's team has maximum y players alive
// 22) X has achievement with id Y unlocked
// 23) X has not achievement with id Y unlocked
// 24) X is a bot
// 25) X is not a bot
// 26) X is holding weapon Y
// 27) X is not holding weapon Y

// __TEAM FORTRESS 2__
// 100) [capture] Participants is minimum x players
// 101) [capture] Participants is maximum x players
// 102) Was (any) critical
// 103) Was real critical
// 104) Was mini critical
// 105) Was not critical
// 106) x is covered in jarate
// 107) x is not covered in jarate
// 108) x is buffed by buff banner
// 109) x is not buffed by buff banner

public bool:Requirement(id, String:x[512], String:y[512], target0, target1, target2) {
    // COMMON
    new any:client = target0;
    if (StringToInt(x) == 1) client = target1;
    if (StringToInt(x) == 2) client = target2;
    
    new bool:IsValidClient_client = IsValidClient(client);
    new bool:IsPlayerAlive_client = false;
    new GetClientHealth_client;
    new GetClientTeam_client;
    new TFClassType:TF2_GetPlayerClass_client;
    new L4D2_ZombieClass_client;
    
    if (IsValidClient_client) {
        IsPlayerAlive_client = IsPlayerAlive(client);
        GetClientHealth_client = GetClientHealth(client);
        GetClientTeam_client = GetClientTeam(client);
        if (g_Gamemode == 1) TF2_GetPlayerClass_client = TF2_GetPlayerClass(client);
        if (g_Gamemode == 2) L4D2_ZombieClass_client = GetEntProp(client, Prop_Send, "m_zombieClass");
    }
    
    new bool:TempInputString_ContainsX = StrContains(TempInputString,x) != -1;
    new StringToInt_y = StringToInt(y);
    new StringToInt_x = StringToInt(x);
    
    if (id == 1 && IsValidClient_client && IsPlayerAlive_client) return true;
    if (id == 2 && IsValidClient_client && !IsPlayerAlive_client) return true;
    if (id == 3 && IsValidClient_client && GetClientHealth_client >= StringToInt_y) return true;
    if (id == 4 && IsValidClient_client && GetClientHealth_client <= StringToInt_y) return true;
    if (id == 5 && target0 != target1) {
        if (GetConVarInt(cvar_debug) == 1) PrintToChatAll("%N != %N", target0, target1);
        return true;
    }  
    if (id == 6 && IsValidClient(target0) && IsValidClient(target1) && target0 == target1) return true;
    if (id == 7 && TempInputString_ContainsX) return true;
    if (id == 8 && !TempInputString_ContainsX) return true;
    if (id == 9 && StrEqual(TempInputString,x)) return true;
    if (id >= 10 && id <= 12 && IsValidClient_client) {
        new String:name[128];
        GetClientName(client, name, sizeof(name));
        if (id == 10 && StringToInt_y) return true;
        if (id == 11 && !StringToInt_y) return true;
        if (id == 12 && StrEqual(name, y)) return true;
    }
    if (id == 13 && IsValidClient_client) {
        new String:steamid[128];
        GetClientAuthString(client, steamid, sizeof(steamid));
        steamid[6] = '0';
        if (GetConVarInt(cvar_debug) == 1) PrintToChatAll("Target: %N, '%s' = '%s'", client, steamid, y);
        if (StrEqual(steamid, y)) return true;
    }
    if (id == 14) {
        if (g_Gamemode == 1 && TF2_GetPlayerClass_client == TFClass_Scout && StrEqual(y, "scout")) return true;
        if (g_Gamemode == 1 && TF2_GetPlayerClass_client == TFClass_Soldier && StrEqual(y, "soldier")) return true;
        if (g_Gamemode == 1 && TF2_GetPlayerClass_client == TFClass_Pyro && StrEqual(y, "pyro")) return true;
        if (g_Gamemode == 1 && TF2_GetPlayerClass_client == TFClass_DemoMan && StrEqual(y, "demoman")) return true;
        if (g_Gamemode == 1 && TF2_GetPlayerClass_client == TFClass_Heavy && StrEqual(y, "heavy")) return true;
        if (g_Gamemode == 1 && TF2_GetPlayerClass_client == TFClass_Engineer && StrEqual(y, "engineer")) return true;
        if (g_Gamemode == 1 && TF2_GetPlayerClass_client == TFClass_Sniper && StrEqual(y, "sniper")) return true;
        if (g_Gamemode == 1 && TF2_GetPlayerClass_client == TFClass_Medic && StrEqual(y, "medic")) return true;
        if (g_Gamemode == 1 && TF2_GetPlayerClass_client == TFClass_Spy && StrEqual(y, "spy")) return true;
        if (g_Gamemode == 2 && L4D2_ZombieClass_client == 1 && StrEqual(y, "smoker")) return true;
        if (g_Gamemode == 2 && L4D2_ZombieClass_client == 2 && StrEqual(y, "boomer")) return true;
        if (g_Gamemode == 2 && L4D2_ZombieClass_client == 3 && StrEqual(y, "hunter")) return true;
        if (g_Gamemode == 2 && L4D2_ZombieClass_client == 4 && StrEqual(y, "spitter")) return true;
        if (g_Gamemode == 2 && L4D2_ZombieClass_client == 5 && StrEqual(y, "jockey")) return true;
        if (g_Gamemode == 2 && L4D2_ZombieClass_client == 6 && StrEqual(y, "charger")) return true;
        if (g_Gamemode == 2 && g_ClientConditions[client] == 5 && StrEqual(y, "zoey")) return true;
        if (g_Gamemode == 2 && g_ClientConditions[client] == 6 && StrEqual(y, "francis")) return true;
        if (g_Gamemode == 2 && g_ClientConditions[client] == 7 && StrEqual(y, "louis")) return true;
        if (g_Gamemode == 2 && g_ClientConditions[client] == 0 && StrEqual(y, "nick")) return true;
        if (g_Gamemode == 2 && g_ClientConditions[client] == 1 && StrEqual(y, "rochelle")) return true;
        if (g_Gamemode == 2 && g_ClientConditions[client] == 2 && StrEqual(y, "coach")) return true;
        if (g_Gamemode == 2 && g_ClientConditions[client] == 3 && StrEqual(y, "ellis")) return true;
    }
    if (id == 15) {
        if (GetClientTeam_client == 1 && StrEqual(y, "spectator")) return true;
        if (GetClientTeam_client == 2 && StrEqual(y, "red")) return true;
        if (GetClientTeam_client == 2 && StrEqual(y, "survivor")) return true;
        if (GetClientTeam_client == 3 && StrEqual(y, "blu")) return true;
        if (GetClientTeam_client == 3 && StrEqual(y, "blue")) return true;
        if (GetClientTeam_client == 3 && StrEqual(y, "infected")) return true;
        if (GetClientTeam_client == 3 && StrEqual(y, "zombie")) return true;
        if (GetClientTeam_client == StringToInt_y) return true;
    }
    if (id >= 16 && id <= 17) {
        new any:client2 = target0;
        if (StringToInt_y == 1) client2 = target1;
        if (StringToInt_y == 2) client2 = target2;
        if (id == 16 && GetClientTeam_client == GetClientTeam(client2)) return true;
        if (id == 17 && GetClientTeam_client != GetClientTeam(client2)) return true;
    }
    if (id >= 18 && id <= 19) {
        new any:client2 = target0;
        if (StringToInt_y == 1) client2 = target1;
        if (StringToInt_y == 2) client2 = target2;
        if (id == 18 && client == client2) return true;
        if (id == 19 && client != client2) return true;
    }
    if (id >= 20 && id <= 21) {
        new players = 0;
        for (new i = 1; i <= MaxClients; i++) {
            if (IsValidClient(i) && IsPlayerAlive(i) && GetClientTeam_client == GetClientTeam(i)) {
                players += 1;
            }
        }
        if (id == 20 && players >= StringToInt_y) return true;
        if (id == 21 && players <= StringToInt_y) return true;
    }
    if (id >= 22 && id <= 23) {
        for (new i = 0; i < GetArraySize(g_Achievements_User); i++) {
            new any:trie = GetArrayCell(g_Achievements_User, i);
            new String:tclient;
            new any:achid;
            GetTrieValue(trie, "client", tclient);
            GetTrieValue(trie, "achid", achid);
            if (tclient == client && achid == StringToInt_y) {
                new any:complete;
                GetTrieValue(trie, "complete", complete);
                if (id == 22 && complete > 0) return true;
                if (id == 23 && complete <= 0) return true;
            }
        }
    }
    if (id == 24 && IsValidClient_client && IsFakeClient(client)) return true;
    if (id == 25 && IsValidClient_client && !IsFakeClient(client)) return true;
    if (id >= 26 && id <= 27 && IsValidClient_client) {
        decl String:weapon[128];
        GetClientWeapon(client, weapon, sizeof(weapon));
        if (id == 26 && StrEqual(weapon, y)) return true;
        if (id == 27 && (!(StrEqual(weapon, y)))) return true;
    }
    
    // TEAM FORTRESS 2
    if (id == 100 && Req_Capture_Count >= StringToInt_x) return true;
    if (id == 101 && Req_Capture_Count <= StringToInt_x) return true;
    if (id == 102 && TempInputCrit > 0) return true;
    if (id == 103 && TempInputCrit == 1) return true;
    if (id == 104 && TempInputCrit == 2) return true;
    if (id == 105 && TempInputCrit == 0) return true;
    if (id >= 106 && id <= 109) {
        new condition = g_ClientConditions[client];
        if (id == 106 && (condition & DF_CRITS_JARATE)) return true;
        if (id == 107 && (!(condition & DF_CRITS_JARATE))) return true;
        if (id == 108 && (condition & DF_CRITS_BUFFBANNER)) return true;
        if (id == 109 && (!(condition & DF_CRITS_BUFFBANNER))) return true;
    }
    if (id == 110 && TF2IsItemName(x, TempInputString)) return true;
    if (id == 111 && (!TF2IsItemName(x, TempInputString))) return true;
    if (id == 112 && Req_Crafted) return true;
    if (id == 113 && (!Req_Crafted)) return true;
    
    // return false if no true
    return false;
}