#define g_DBName_get "mw_achievements_get"
#define g_DBName_post "mw_achievements_post"

new Handle:db_post = INVALID_HANDLE;

public GetAchievementInfo() {
    new Handle:db = INVALID_HANDLE;
    
    if (SQL_CheckConfig(g_DBName_get)) {
        decl String:Error[256];
        db = SQL_Connect(g_DBName_get, true, Error, sizeof(Error));

        if (db == INVALID_HANDLE) LogError("Failed to connect to database: %s", Error);
        else if (!SQL_FastQuery(db, "SET NAMES 'utf8'")) {
            if (SQL_GetError(db, Error, sizeof(Error))) LogError("Failed to update encoding to UTF8: %s", Error);
            else LogError("Failed to update encoding to UTF8: unknown");
        }
    }
    else LogError("Database.cfg missing '%s' entry!", g_DBName_get);
    
    // Clear arrays
    for (new i = 0; i < GetArraySize(g_Achievements_Server); i++) CloseHandle(GetArrayCell(g_Achievements_Server, i));
    for (new i = 0; i < GetArraySize(g_Blocks_Server); i++) CloseHandle(GetArrayCell(g_Blocks_Server, i));
    ClearArray(g_Achievements_Server);
    ClearArray(g_Blocks_Server);
    
    /// Time to get it off the sql
    decl String:strQuery[255];
    decl String:temp[255];
    Format(strQuery, sizeof(strQuery), "SELECT * FROM mw_achievements_get_ach");
    
    /// GET ACHIEVEMENTS
    // Request handle
    new Handle:strHQuery;
    decl String:strError[255];
    if ((strHQuery = SQL_Query(db, strQuery)) == INVALID_HANDLE) {
        SQL_GetError(db, strError, sizeof(strError));
        LogError("'Count strQuery' failed: %s", strQuery);
        LogError("Query error: %s", strError);
        return;
    }
    // Fetch it
    while (SQL_FetchRow(strHQuery)) {
        new Handle:trie = CreateTrie();
        // id
        SetTrieValue(trie, "id", SQL_FetchInt(strHQuery, 0));
        // name
        SQL_FetchString(strHQuery, 1,temp,sizeof(temp));
        SetTrieString(trie, "name", temp);
        // desc
        SQL_FetchString(strHQuery, 2,temp,sizeof(temp));
        SetTrieString(trie, "desc", temp);
        // triggers
        SetTrieValue(trie, "triggers", SQL_FetchInt(strHQuery, 3));
        // blocks
        SQL_FetchString(strHQuery, 4,temp,sizeof(temp));
        SetTrieString(trie, "blocks", temp);
        // game
        SetTrieValue(trie, "game", SQL_FetchInt(strHQuery, 5));
        
        // insert
        PushArrayCell(g_Achievements_Server, trie);
    }
    CloseHandle(strHQuery);
    
    /// GET BLOCKS
    Format(strQuery, sizeof(strQuery), "SELECT * FROM mw_achievements_get_blocks");
    if ((strHQuery = SQL_Query(db, strQuery)) == INVALID_HANDLE) {
        SQL_GetError(db, strError, sizeof(strError));
        LogError("'Count strQuery' failed: %s", strQuery);
        LogError("Query error: %s", strError);
        return;
    }
    // Fetch it
    while (SQL_FetchRow(strHQuery)) {
        new Handle:trie = CreateTrie();
        // id
        SetTrieValue(trie, "id", SQL_FetchInt(strHQuery, 0));
        // name
        SQL_FetchString(strHQuery, 1,temp,sizeof(temp));
        SetTrieString(trie, "event", temp);
        // desc
        SetTrieValue(trie, "target", SQL_FetchInt(strHQuery, 2));
        // triggers
        SetTrieValue(trie, "triggers", SQL_FetchInt(strHQuery, 3));
        // add
        SetTrieValue(trie, "add", SQL_FetchInt(strHQuery, 4));
        // requirement
        SQL_FetchString(strHQuery, 5,temp,sizeof(temp));
        SetTrieString(trie, "requirement", temp);
        // expire
        SQL_FetchString(strHQuery, 6,temp,sizeof(temp));
        SetTrieString(trie, "expire", temp);
        
        // insert
        PushArrayCell(g_Blocks_Server, trie);
    }
    CloseHandle(strHQuery);
    
    // Close database connection
    CloseHandle(db);
}

public GetClientDBInfo(client) {
    decl String:strSteamId[128];
    GetClientAuthString(client, strSteamId, sizeof(strSteamId));
    strSteamId[6] = '0';
    
    // Clear arrays
    for (new i_t = 0; i_t < GetArraySize(g_Achievements_User); i_t++) {
        new i = GetArraySize(g_Achievements_User)-i_t-1;
        new any:trie = GetArrayCell(g_Achievements_User, i);
        decl String:steamid[128];
        GetTrieString(trie, "steamid", steamid, sizeof(steamid));
        steamid[6] = '0';
        if (StrEqual(steamid, strSteamId)) {
            CloseHandle(trie);
            RemoveFromArray(g_Achievements_User, i);
        }
    }
    for (new i_t = 0; i_t < GetArraySize(g_Blocks_User); i_t++) {
        new i = GetArraySize(g_Blocks_User)-i_t-1;
        new any:trie = GetArrayCell(g_Blocks_User, i);
        decl String:steamid[128];
        GetTrieString(trie, "steamid", steamid, sizeof(steamid));
        steamid[6] = '0';
        if (StrEqual(steamid, strSteamId)) {
            CloseHandle(trie);
            RemoveFromArray(g_Blocks_User, i);
        }
    }
    
    if (!IsValidClient(client) || IsFakeClient(client)) return;

    new Handle:db = INVALID_HANDLE;
    
    if (SQL_CheckConfig(g_DBName_get)) {
        decl String:Error[256];
        db = SQL_Connect(g_DBName_get, true, Error, sizeof(Error));

        if (db == INVALID_HANDLE) LogError("Failed to connect to database: %s", Error);
        else if (!SQL_FastQuery(db, "SET NAMES 'utf8'")) {
            if (SQL_GetError(db, Error, sizeof(Error))) LogError("Failed to update encoding to UTF8: %s", Error);
            else LogError("Failed to update encoding to UTF8: unknown");
        }
    }
    else LogError("Database.cfg missing '%s' entry!", g_DBName_get);
    
    /// Time to get it off the sql
    decl String:strQuery[255];
    decl String:temp[255];
    GetClientAuthString(client, strSteamId, sizeof(strSteamId));
    strSteamId[6] = '0';
    Format(strQuery, sizeof(strQuery), "SELECT * FROM `mw_achievements_post_ach` WHERE steamid = '%s'", strSteamId);
    
    /// GET ACHIEVEMENTS
    // Request handle
    new Handle:strHQuery;
    decl String:strError[255];
    if ((strHQuery = SQL_Query(db, strQuery)) == INVALID_HANDLE) {
        SQL_GetError(db, strError, sizeof(strError));
        LogError("'Count strQuery' failed: %s", strQuery);
        LogError("Query error: %s", strError);
        return;
    }
    // Fetch it
    while (SQL_FetchRow(strHQuery)) {
        new Handle:trie = CreateTrie();
        // client
        SetTrieValue(trie, "client", client);
        // id
        SQL_FetchString(strHQuery, 0,temp,sizeof(temp));
        temp[6] = '0';
        SetTrieString(trie, "id", temp);
        // achid
        SetTrieValue(trie, "achid", SQL_FetchInt(strHQuery, 1));
        // steamid
        SQL_FetchString(strHQuery, 2,temp,sizeof(temp));
        temp[6] = '0';
        SetTrieString(trie, "steamid", temp);
        // triggers
        SetTrieValue(trie, "triggers", SQL_FetchInt(strHQuery, 3));
        // triggers
        SetTrieValue(trie, "complete", SQL_FetchInt(strHQuery, 4));
        // insert
        PushArrayCell(g_Achievements_User, trie);
    }
    CloseHandle(strHQuery);
    
    // Close database connection
    CloseHandle(db);
}

public ConnectDB_Post() {
    if (SQL_CheckConfig(g_DBName_post))
    {
        decl String:Error[256];
        db_post = SQL_Connect(g_DBName_post, true, Error, sizeof(Error));

        if (db_post == INVALID_HANDLE)
            LogError("Failed to connect to database: %s", Error);
        else if (!SQL_FastQuery(db_post, "SET NAMES 'utf8'"))
        {
            if (SQL_GetError(db_post, Error, sizeof(Error)))
                LogError("Failed to update encoding to UTF8: %s", Error);
            else
                LogError("Failed to update encoding to UTF8: unknown");
        }
    }
    else
        LogError("Database.cfg missing '%s' entry!", g_DBName_post);
}

public UpdateUserAchievement(any:client, any:achid, any:triggers, any:complete) {
    if (GetConVarBool(cvar_nosend)) return;
    g_motd[client] += 1;

    //PrintToChatAll("clien: %N, achid: %d, triggers: %d, complete: %d", client, achid, triggers, complete);
    decl String:id[128];
    decl String:strSteamId[128];
    GetClientAuthString(client, strSteamId, sizeof(strSteamId));
    strSteamId[6] = '0';
    Format(id, sizeof(id), "%s_%d", strSteamId, achid);

    decl String:strQuery[512];
    Format(strQuery, sizeof(strQuery), "INSERT INTO `mw_achievements_post_ach` (`id`, `achid`, `steamid`, `triggers`, `complete`) VALUES ('%s', '%d', '%s', '%d', '%d') ON DUPLICATE KEY UPDATE `triggers` = VALUES(`triggers`), `complete` = VALUES(`complete`)", id, achid, strSteamId, triggers, complete);
    SQL_TQuery(db_post, QueryCallback, strQuery);
}

public QueryCallback(Handle:argOwner, Handle:argHndl, const String:argError[], any:argData)
{
    if (argHndl == INVALID_HANDLE)
    {
        LogError("Query Error: %s",argError);
    }
}

public UpdateClient(any:client) {
    if (g_ClientUpdate[client] == false) return;
    
    for (new i = 0; i < GetArraySize(g_Achievements_Update); i++) {
        new c_client = GetArrayCell(g_Achievements_Update, i);
        if (c_client == client) {
            new id = GetArrayCell(g_Achievements_Update, i, 1);
            for (new i2 = 0; i2 < GetArraySize(g_Achievements_User); i2++) {
                new any:trie = GetArrayCell(g_Achievements_User, i2);
                new achid;
                new achclient;
                GetTrieValue(trie, "achid", achid);
                GetTrieValue(trie, "client", achclient);
                if (id == achid && client == achclient) {
                    new triggers;
                    new complete;
                    GetTrieValue(trie, "complete", complete);
                    GetTrieValue(trie, "triggers", triggers);
                    UpdateUserAchievement(client, achid, triggers, complete);
                }
            }
            RemoveFromArray(g_Achievements_Update, i);
        }
    }

    g_ClientUpdate[client] = false;
}